(function ($, Drupal, once) {

  Drupal.behaviors.spaIframeResizer = {
    attach: function (context, settings) {

      $(once('init-spa-iframes', 'body')).each(function () {
        iFrameResize({
          resizeFrom: 'child',
          onInit: function (messageData) {
            let $self = $('#' + messageData.id);
            $self.parent().css('position', 'relative');
            $self.before(Drupal.theme.ajaxProgressThrobber());
          },
          onResized: function (messageData) {
            // Sometimes the iframe resizes to fast, so the progress throbber
            // is not yet in DOM. Therefore, we wait for it to appear.
            let $throbber, i = setInterval(function () {
              $throbber = $('#' + messageData.id).parent().find('.ajax-progress');
              if ($throbber.length > 0) {
                $throbber.remove();
                clearInterval(i);
              }
            }, 200);
          }
        }, '.spa-iframe');
      });

    },
  };

})(jQuery, Drupal, once);
