<?php

namespace Drupal\spa\Plugin\SpaLibrary;

/**
 * Plugin implementation of the spa_library.
 *
 * @SpaLibrary(
 *   id = "css_external",
 *   label = @Translation("CSS External")
 * )
 */
class CssExternal extends ExternalBase {

  /**
   * {@inheritdoc}
   */
  public function setLibraryDefinition(&$definition): void {
    $definition['css']['component'][$this->configuration['url']] = [
      'type' => 'external',
      'minified' => $this->configuration['minified'],
      'attributes' => [
        'async' => (bool) $this->configuration['async'],
        'defer' => (bool) $this->configuration['defer']
      ],
    ];
  }
}
