<?php

namespace Drupal\spa;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;

/**
 * SpaArgument plugin manager.
 */
class SpaArgumentPluginManager extends DefaultPluginManager {

  /**
   * Constructs SpaArgumentPluginManager object.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct(
      'Plugin/SpaArgument',
      $namespaces,
      $module_handler,
      'Drupal\spa\SpaArgumentInterface',
      'Drupal\spa\Annotation\SpaArgument'
    );
    $this->alterInfo('spa_argument_info');
    $this->setCacheBackend($cache_backend, 'spa_argument_plugins');
  }

}
