<?php

namespace Drupal\spa;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use \Symfony\Component\HttpFoundation\Response;

/**
 * Interface for spa_library plugins.
 */
interface SpaLibraryInterface extends PluginFormInterface, ConfigurableInterface {

  /**
   * Returns the translated plugin label.
   *
   * @return string
   *   The translated title.
   */
  public function label();

  /**
   * Content that the library provides
   */
  public function getContent(): Response;

  /**
   * Set library definitions for hook_library_info_build.
   *
   * @param $definition
   *   Library definitions.
   */
  public function setLibraryDefinition(&$definition): void;

  /**
   * Get library dependencies.
   *
   * @return array
   */
  public function getDependencies(): array;

}
